gstreamer-0.12.1.2: Binding to the GStreamer open source multimedia framework.

Portability | portable (depends on GHC)
Stability | provisional
Maintainer | gtk2hs-users@lists.sourceforge.net
Safe Haskell | None

Media.Streaming.GStreamer.Core.MiniHierarchy

Description

This file reflects the Gtk+ object hierarchy in terms of Haskell classes.

Note: the mk... functions were originally meant to simply be an alias for the constructor. However, in order to communicate the destructor of an object to objectNew, the mk... functions are now a tuple containing Haskell constructor and the destructor function pointer. This hack avoids changing all modules that simply pass mk... to objectNew.

Synopsis

- miniObjectUnref :: FinalizerPtr a
- newtype MiniObject = MiniObject (ForeignPtr MiniObject)
- class MiniObjectClass o where
  - toMiniObject :: o -> MiniObject
  - unsafeCastMiniObject :: MiniObject -> o
- mkMiniObject :: (ForeignPtr MiniObject -> MiniObject, FinalizerPtr a)
- unMiniObject :: MiniObject -> ForeignPtr MiniObject
- isMiniObject :: MiniObjectClass obj => obj -> Bool
- castToMiniObject :: MiniObjectClass obj => obj -> MiniObject
- newtype Buffer = Buffer (ForeignPtr Buffer)
- class MiniObjectClass o => BufferClass o
- toBuffer :: BufferClass o => o -> Buffer
- mkBuffer :: (ForeignPtr Buffer -> Buffer, FinalizerPtr a)
- unBuffer :: Buffer -> ForeignPtr Buffer
- castToBuffer :: MiniObjectClass obj => obj -> Buffer
- gTypeBuffer :: GType
- newtype Event = Event (ForeignPtr Event)
- class MiniObjectClass o => EventClass o
- toEvent :: EventClass o => o -> Event
- mkEvent :: (ForeignPtr Event -> Event, FinalizerPtr a)
- unEvent :: Event -> ForeignPtr Event
- castToEvent :: MiniObjectClass obj => obj -> Event
- gTypeEvent :: GType
- newtype Message = Message (ForeignPtr Message)
- class MiniObjectClass o => MessageClass o
- toMessage :: MessageClass o => o -> Message
- mkMessage :: (ForeignPtr Message -> Message, FinalizerPtr a)
- unMessage :: Message -> ForeignPtr Message
- castToMessage :: MiniObjectClass obj => obj -> Message
- gTypeMessage :: GType
- newtype Query = Query (ForeignPtr Query)
- class MiniObjectClass o => QueryClass o
- toQuery :: QueryClass o => o -> Query
- mkQuery :: (ForeignPtr Query -> Query, FinalizerPtr a)
- unQuery :: Query -> ForeignPtr Query
- castToQuery :: MiniObjectClass obj => obj -> Query
- gTypeQuery :: GType

# Documentation

miniObjectUnref :: FinalizerPtr a

Decrease the reference counter of an object

newtype MiniObject

Constructors

MiniObject (ForeignPtr MiniObject) |

Instances

MiniObjectClass MiniObject |

class MiniObjectClass o where

Methods

toMiniObject :: o -> MiniObject

unsafeCastMiniObject :: MiniObject -> o

Instances

MiniObjectClass MiniObject |
MiniObjectClass Query |
MiniObjectClass Message |
MiniObjectClass Event |
MiniObjectClass Buffer |

mkMiniObject :: (ForeignPtr MiniObject -> MiniObject, FinalizerPtr a)

unMiniObject :: MiniObject -> ForeignPtr MiniObject

isMiniObject :: MiniObjectClass obj => obj -> Bool

castToMiniObject :: MiniObjectClass obj => obj -> MiniObject

newtype Buffer

Constructors

Buffer (ForeignPtr Buffer) |

Instances

Eq Buffer |
Ord Buffer |
MiniObjectClass Buffer |
BufferClass Buffer |

class MiniObjectClass o => BufferClass o

Instances

BufferClass Buffer |

toBuffer :: BufferClass o => o -> Buffer

mkBuffer :: (ForeignPtr Buffer -> Buffer, FinalizerPtr a)

unBuffer :: Buffer -> ForeignPtr Buffer

castToBuffer :: MiniObjectClass obj => obj -> Buffer

gTypeBuffer :: GType

newtype Event

Constructors

Event (ForeignPtr Event) |

Instances

Eq Event |
Ord Event |
MiniObjectClass Event |
EventClass Event |

class MiniObjectClass o => EventClass o

Instances

EventClass Event |

toEvent :: EventClass o => o -> Event

mkEvent :: (ForeignPtr Event -> Event, FinalizerPtr a)

unEvent :: Event -> ForeignPtr Event

castToEvent :: MiniObjectClass obj => obj -> Event

gTypeEvent :: GType

newtype Message

Constructors

Message (ForeignPtr Message) |

Instances

Eq Message |
Ord Message |
MiniObjectClass Message |
MessageClass Message |

class MiniObjectClass o => MessageClass o

Instances

MessageClass Message |

toMessage :: MessageClass o => o -> Message

mkMessage :: (ForeignPtr Message -> Message, FinalizerPtr a)

unMessage :: Message -> ForeignPtr Message

castToMessage :: MiniObjectClass obj => obj -> Message

gTypeMessage :: GType

newtype Query

Constructors

Query (ForeignPtr Query) |

Instances

Eq Query |
Ord Query |
MiniObjectClass Query |
QueryClass Query |

class MiniObjectClass o => QueryClass o

Instances

QueryClass Query |

toQuery :: QueryClass o => o -> Query

mkQuery :: (ForeignPtr Query -> Query, FinalizerPtr a)

unQuery :: Query -> ForeignPtr Query

castToQuery :: MiniObjectClass obj => obj -> Query

gTypeQuery :: GType